<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑' : '添加'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="卡号" name="code">
        <a-input
          allow-clear
          placeholder="请输入卡号"
          :disabled="true"
          v-model:value="form.code"
        />
      </a-form-item>
      <a-form-item label="姓名" name="username">
        <a-input
          allow-clear
          placeholder="请姓名"
          :disabled="true"
          v-model:value="form.username"
        />
      </a-form-item>
      <a-form-item label="手机号码" name="phone">
        <a-input
          allow-clear
          placeholder="phone"
          :disabled="true"
          v-model:value="form.phone"
        />
      </a-form-item>
      <a-form-item label="可使用场馆" name="sid">
        <a-input
          allow-clear
          placeholder="siteName"
          :disabled="true"
          v-model:value="form.sid"
        />
      </a-form-item>
      <a-form-item label="支付方式" name="payType">
        <a-tag v-if="form.payType === 1">微信支付</a-tag>
        <a-tag v-if="form.payType === 2">支付宝支付</a-tag>
        <a-tag v-if="form.payType === 3">现金支付</a-tag>
        <a-tag v-if="form.payType === 4">POS机支付</a-tag>
      </a-form-item>
      <a-form-item label="总次数" name="count">
        <a-input
          allow-clear
          placeholder="总次数"
          :disabled="true"
          v-model:value="form.count"
        />
      </a-form-item>
      <a-form-item label="剩余次数" name="num">
        <a-input
          allow-clear
          placeholder="剩余次数"
          :disabled="true"
          v-model:value="form.num"
        />
      </a-form-item>
      <a-form-item label="余额" name="remainingMoney">
        <a-input
          allow-clear
          placeholder="余额"
          :disabled="true"
          v-model:value="form.remainingMoney"
        />
      </a-form-item>
      <a-form-item label="IC卡类型" name="type">
        <a-radio-group
          v-model:value="form.type"
          button-style="solid"
          :disabled="true"
        >
          <a-radio-button :value="1">年卡</a-radio-button>
          <a-radio-button :value="2">次卡</a-radio-button>
          <a-radio-button :value="3">月卡</a-radio-button>
          <a-radio-button :value="4">会员IC卡</a-radio-button>
          <a-radio-button :value="5">充值卡</a-radio-button>
        </a-radio-group>
      </a-form-item>
      <a-form-item label="到期时间" name="expireTime">
        {{ toDateString(form.expireTime, 'yyyy-MM-dd HH:mm:ss') }}
        <!--        <a-date-picker-->
        <!--          v-model:value="form.expireTime"-->
        <!--          show-time-->
        <!--          placeholder="Select Time"-->
        <!--          format=""-->
        <!--          value-format="YYYY-MM-DD HH:mm:ss"-->
        <!--          class="ele-fluid"-->
        <!--        />-->
      </a-form-item>

      <a-form-item label="本次充值金额" name="money">
        <a-input
          allow-clear
          placeholder="请输入充值金额"
          v-model:value="form.money"
        />
      </a-form-item>
      <a-form-item label="本次充值次数" name="count">
        <a-input allow-clear placeholder="请输入" v-model:value="form.count" />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import {
    addThinkCardLog,
    updateThinkCardLog
  } from '@/api/think/thinkCardLog';
  import { isExternalLink, random, toDateString } from 'ele-admin-pro';
  import { ThinkCardLog } from '@/api/think/thinkCardLog/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkCardLog | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkCardLog>({
    id: undefined,
    code: undefined,
    payType: undefined,
    sid: undefined,
    money: undefined,
    num: undefined,
    phone: undefined,
    aid: undefined,
    type: undefined,
    cardType: undefined,
    remainingMoney: undefined,
    wechatOrder: undefined,
    expireTime: undefined,
    createTime: undefined,
    count: undefined,
    username: ''
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkCardLogName: [
      {
        required: true,
        type: 'string',
        message: '请填写名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value
          ? updateThinkCardLog
          : addThinkCardLog;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if (props.data.image) {
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            });
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
